ALTER PROCEDURE [dbo].[P_DiscountOrder](@R int=1, @UniKey int=null OUTPUT,
@OrderKey int=null,
@SourceType int=null,
@SourceKey int=null,
@SourceDetailKey int=null,
@DiscountType int=null,
@DiscountValueType int=null,
@DiscountValue float=null,
@Limit float=null,
@isFree bit=0,
--  
@VipKey int=null,
@CardKey int=null,
@PhoneKey int=null,
@CurrentUserUniKey int=null,
@SelectOrder varchar(2000)=null
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <27.05.2015>
-- Update date: <09	.07.2015>
-- Description:	<     >
-- =============================================
SET DATEFORMAT dmy;
DECLARE @Q varchar(4000), @tmp int,@tmp2 int, @StartTravelCount int, @LngMain varchar(2);
DECLARE @isEnabledDiscountSimpleVIP bit, @isEnabledDiscountSimpleCards bit,
@isEnabledDiscountAccumulatedPhone bit, @isEnabledDiscountAccumulatedVIP bit;
SELECT TOP 1 @LngMain=LngMain FROM PROPERTIES;
	--     
	if @R=1
		begin
		SELECT TOP 1 @isEnabledDiscountSimpleVIP=isAddToOrder FROM DiscountSourceType DST WHERE UniKey=1 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountSimpleCards=isAddToOrder FROM DiscountSourceType DST WHERE UniKey=2 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountAccumulatedPhone=isAddToOrder FROM DiscountSourceType DST WHERE UniKey=3 AND Lng LIKE @LngMain;
		SELECT TOP 1 @isEnabledDiscountAccumulatedVIP=isAddToOrder FROM DiscountSourceType DST WHERE UniKey=4 AND Lng LIKE @LngMain;
		--       
		create table #tbl_discount_order (UniKey int NOT NULL, SourceType int, SourceKey int,
			SourceDetailKey int,
			DiscountType int, DiscountValueType int, DiscountValue float, Limit money, isFree bit);
		CREATE INDEX #tbl_UniKey_ind ON #tbl_discount_order(UniKey);

		--    VIP 
		if @isEnabledDiscountSimpleVIP=1
			begin
			insert #tbl_discount_order
				SELECT UniKey, 1, @VipKey, null, DiscountType, DiscountValueType, DiscountValue, 0,0
				FROM VipDiscountRegular WHERE VIPKey=@VipKey AND DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE());
			end;
		--     
		if @isEnabledDiscountSimpleCards=1
			begin
			insert #tbl_discount_order
				SELECT UniKey, 2, @VipKey, null, DiscountType, DiscountValueType, DiscountValue, 0,0
				FROM CardsDiscountRegular WHERE CardKey=@CardKey AND DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE());
			end;
	/*     VIP*/
		if @isEnabledDiscountAccumulatedVIP=1
		begin
			-- 
			insert #tbl_discount_order
				SELECT VD.UniKey,4,VD.UniKey,NULL,1,1,VD.DiscountSum,DDD.FreeLimit,VD.isFree
				  FROM VipDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount
				  WHERE VD.VIP=@VipKey AND Zakaz IS NULL AND isEnabled=1 AND (VD.DiscountSum!=0 OR (VD.DiscountPercent=0 AND VD.isFree=1))
			-- %
			insert #tbl_discount_order
				SELECT VD.UniKey,4,VD.UniKey,NULL,1,2,VD.DiscountPercent,DDD.FreeLimit,VD.isFree
				  FROM VipDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount
				  WHERE VD.VIP=@VipKey AND Zakaz IS NULL AND isEnabled=1 AND VD.DiscountPercent!=0
		end;
	/*      */
		if @isEnabledDiscountAccumulatedPhone=1
		begin
			-- 
			insert #tbl_discount_order
				SELECT VD.UniKey,3,VD.UniKey,NULL,1,1,VD.DiscountSum,DDD.FreeLimit,VD.isFree
				  FROM PhoneDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount
				  WHERE VD.PhoneKey=@PhoneKey AND Zakaz IS NULL AND isEnabled=1 AND (VD.DiscountSum!=0 OR (VD.DiscountPercent=0 AND VD.isFree=1))
			-- %
			insert #tbl_discount_order
				SELECT VD.UniKey,3,VD.UniKey,NULL,1,2,VD.DiscountPercent,DDD.FreeLimit,VD.isFree
				  FROM PhoneDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount
				  WHERE VD.PhoneKey=@PhoneKey AND Zakaz IS NULL AND isEnabled=1 AND VD.DiscountPercent!=0
		end;
			

		-- 
		SELECT RES.*,DT.DiscountTypeName, DVT.DiscountValueTypeUserName as DiscountValueTypeName,DST.DiscountSourceTypeNameReport as DiscountSourceTypeName FROM #tbl_discount_order as RES
			LEFT JOIN DiscountType DT ON DT.UniKey=RES.DiscountType AND DT.Lng LIKE @LngMain
			LEFT JOIN DiscountValueType DVT ON DVT.UniKey=RES.DiscountValueType AND DVT.Lng LIKE @LngMain
			LEFT JOIN DiscountSourceType DST ON DST.UniKey=RES.SourceType AND DST.Lng LIKE @LngMain

		drop table #tbl_discount_order;			
		return;
		end;
	--      
	if @R=2
		begin
		SELECT DO.*,DT.DiscountTypeName, DVT.DiscountValueTypeUserName as DiscountValueTypeName,DST.DiscountSourceTypeNameReport as DiscountSourceTypeName FROM DiscountOrders DO
			LEFT JOIN DiscountType DT ON DT.UniKey=DO.DiscountType AND DT.Lng LIKE @LngMain
			LEFT JOIN DiscountValueType DVT ON DVT.UniKey=DO.DiscountValueType AND DVT.Lng LIKE @LngMain
			LEFT JOIN DiscountSourceType DST ON DST.UniKey=DO.SourceType AND DST.Lng LIKE @LngMain
			WHERE DO.OrderKey=@UniKey;
		return;
		end;
		
	--      
	if @R=3
		begin
		select @tmp=DO.SourceType,@tmp2=DO.SourceKey FROM DiscountOrders DO WHERE UniKey=@UniKey;
		--   VIP
		if @tmp=4
			begin
			UPDATE VipDiscount SET Zakaz=NULL WHERE UniKey=@tmp2;			
			end;
		--     
		if @tmp=3
			begin
			UPDATE PhoneDiscount SET Zakaz=NULL WHERE UniKey=@tmp2;			
			end;
		DELETE FROm DiscountOrders WHERE UniKey=@UniKey;
		return;
		end;
	--      
	if @R=4
		begin
		INSERT INTO DiscountOrders (OrderKey,SourceType,SourceKey,SourceDetailKey,
			DiscountType,DiscountValueType, DiscountValue,Limit,UserCreate,isFree)
		VALUES (@OrderKey,@SourceType,@SourceKey,@SourceDetailKey,
			@DiscountType,@DiscountValueType, @DiscountValue,@Limit,@CurrentUserUniKey,@isFree);
		SET @UniKey=SCOPE_IDENTITY();
		--   VIP
		if @SourceType=4
			begin
			UPDATE VipDiscount SET Zakaz=@OrderKey WHERE UniKey=@SourceKey;
			end;
		--     
		if @SourceType=3
			begin
			UPDATE PhoneDiscount SET Zakaz=@OrderKey WHERE UniKey=@SourceKey;
			end;		
		return;
		end;
END
